/*
OLED_SSD1331_2 Test
 
 */


#include <Adafruit_GFX_oled.h>
#include <OLED_SSD1331_2.h>
//#include <OLED_SSD1331.h>
#include <SD.h>
#include <SPI.h>

/*
Note for Teensy 3.x !!!!!!!!!!!!!!!!!!!
 You should choose from those pins for CS and RS:
 2,6,9,10,15,20,23
 */
#define cs               20 //10
#define rst              14
#define dc               15 //9
#define SD_CS             6 //4    // Set the chip select line to whatever you use (4 doesnt conflict with the library)

// Color definitions
#define	BLACK           0x0000
#define	BLUE            0x001F
#define	RED             0xF800
#define	GREEN           0x07E0
#define CYAN            0x07FF
#define MAGENTA         0xF81F
#define YELLOW          0xFFE0  
#define WHITE           0xFFFF
#define TRANSPARENT     -1

// Bitmap
#define BUFFPIXEL 20

// OLED Display
OLED_SSD1331_2 display = OLED_SSD1331_2(cs, dc, rst);
//OLED_SSD1331 display = OLED_SSD1331(cs, dc, rst);


// Bitmap from SD
// the file itself
File bmpFile;
bool sdReady;
// information we extract about the bitmap file
int bmpWidth, bmpHeight;
uint8_t bmpDepth, bmpImageoffset;


float p = 3.1415926;

void setup(void) {
  //Bitmap
  //SD.begin must be set before display.begin. Otherwhise SPI will be slow whne no SD-Card inserted
  sdReady = SD.begin(SD_CS);
  //---
  
  display.begin(); //OLED: display.begin must be set after SD.begin !
  display.setBitrate(24000000);
    
  //display.setRotation(0); //0: Pins are at bottom
  //display.setRotation(1); //1: Pins are at left
  display.setRotation(2); //2: Pins are at top
  //display.setRotation(3); //3: Pins are at right

  uint16_t time = millis();
  time = millis() - time;

  lcdTestPattern();
  delay(2000);
  
  display.clearScreen();
  display.setCursor(0,0);
  display.print("Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur adipiscing ante sed nibh tincidunt feugiat. Maecenas enim massa");
  delay(2000);

/*
  tftPrintTest();
  delay(2000);

  //a single pixel
  display.drawPixel(96/2, 64/2, GREEN);
  delay(500);
  
  randomLines();
  
  // line draw test
  testlines(YELLOW);
  delay(500);    

  // optimized lines
  testfastlines(RED, BLUE);
  delay(500);    

  testdrawrects(GREEN);
  delay(1000);

  testfillrects(BLUE, YELLOW);
  delay(1000);

  randomRect(0);
  delay(100);
  randomCircles(0);
  delay(100);
  randomLines();
  delay(100);
  randomPoints();
  delay(500);
  
  display.clearScreen();
  testfillcircles(10, BLUE);
  testdrawcircles(10, WHITE);
  delay(1000);

  testroundrects();
  delay(500);

  testtriangles();
  delay(500);
*/
}

void loop() {
  tftPrintTest();
  delay(2000);//*/
  
  //Bitmap
  if (sdReady && SD.exists("violet.bmp")) {
      bmpDraw("violet.bmp", 0, 0);
  } 
  else {
      display.clearScreen();
      display.setCursor(0, 25);
      display.setTextColor(RED);  
      display.setTextSize(1);
      display.print("Missing SD-Card!");
  }
  delay(2000);//*/
  //---
  
  display.clearScreen();
  display.fillRect(20, 20, 40, 10, random(0x0010,0xFFFF));
  delay(2000);//*/
  display.hdwre_fillRect(20, 20, 40, 10, random(0x0010,0xFFFF));
  delay(2000);//*/

  display.clearScreen();
  display.drawTriangle(20, 20, 60, 20, 40, 40, random(0x0010,0xFFFF));
  delay(2000);
  
  //display.clearScreen();
  display.fillTriangle(20, 20, 60, 20, 40, 40, random(0x0010,0xFFFF));
  delay(2000);
  
  display.clearScreen();
  display.drawRoundRect(20, 20, 40, 10, 5, random(0x0010,0xFFFF));
  delay(2000);
  
  //display.clearScreen();
  display.drawCircle(20, 20, 10, random(0x0010,0xFFFF));
  delay(2000);
  
  //display.clearScreen();
  display.fillCircle(20, 20, 10, random(0x0010,0xFFFF));
  delay(2000);
  
  //display.clearScreen();
  display.fillRect(20, 20, 40, 10, random(0x0010,0xFFFF));
  //display.drawRect(17, 17, 46, 16,random(0x0010,0xFFFF));
  delay(2000);
  
  display.clearScreen();
  display.drawLine(20, 20, 60, 20, random(0x0010,0xFFFF)); //ok
  //delay(2000);
  display.drawLine(20, 20, 20, 30, random(0x0010,0xFFFF)); //ok
  //delay(2000);
  display.drawLine(60, 20, 60, 30, random(0x0010,0xFFFF)); //ok
  //delay(2000);
  display.drawLine(20, 30, 60, 30, random(0x0010,0xFFFF)); //ok
  delay(2000);
  
  /*display.clearScreen();
  display.drawLine(10, 20, 20, 20, random(0x0010,0xFFFF)); //ok
  //delay(2000);
  display.drawLine(50, 20, 20, 20, random(0x0010,0xFFFF)); //ok
  //delay(2000);
  display.drawLine(20, 10, 20, 20, random(0x0010,0xFFFF)); //ok
  //delay(2000);
  display.drawLine(20, 50, 20, 20, random(0x0010,0xFFFF)); //ok
  delay(2000);
  
  display.clearScreen();
  display.drawLine(20, 10, 20, 50, random(0x0010,0xFFFF)); //ok
  //delay(2000);
  display.drawLine(50, 20, 10, 20, random(0x0010,0xFFFF)); //ok
  delay(2000);
  
  display.clearScreen();
  display.drawLine(10, 20, 50, 20, random(0x0010,0xFFFF)); //ok
  //delay(2000);
  display.drawLine(20, 50, 20, 10, random(0x0010,0xFFFF)); //ok
  delay(2000);
  
  display.clearScreen();
  display.drawLine(10, 10, 50, 50, random(0x0010,0xFFFF)); //
  //delay(2000);
  display.drawLine(10, 50, 50, 10, random(0x0010,0xFFFF)); //
  delay(2000);
  
  display.clearScreen();
  display.drawLine(50, 10, 10, 50, random(0x0010,0xFFFF)); //
  //delay(2000);
  display.drawLine(50, 50, 10, 10, random(0x0010,0xFFFF)); //
  delay(2000);*/
    
  /*testlines(random(0x0010,0xFFFF));
  randomLines();
  randomCircles(0);
  randomPoints();*/
}

// Bitmap from SD-Card
void bmpDraw(char *filename, uint8_t x, uint8_t y) {
  File     bmpFile;
  int      bmpWidth, bmpHeight;   // W+H in pixels
  uint8_t  bmpDepth;              // Bit depth (currently must be 24)
  uint32_t bmpImageoffset;        // Start of image data in file
  uint32_t rowSize;               // Not always = bmpWidth; may have padding
  uint8_t  sdbuffer[3*BUFFPIXEL]; // pixel buffer (R+G+B per pixel)
  uint8_t  buffidx = sizeof(sdbuffer); // Current position in sdbuffer
  boolean  goodBmp = false;       // Set to true on valid header parse
  boolean  flip    = true;        // BMP is stored bottom-to-top
  int      w, h, row, col;
  uint8_t  r, g, b;
  uint32_t pos = 0, startTime = millis();

  if((x >= display.width()) || (y >= display.height())) return;
  // Open requested file on SD card
  if ((bmpFile = SD.open(filename)) == NULL) {
    //Serial.print("File not found");
    sdReady=false;
    return;
  }
  // Parse BMP header
  if(read16(bmpFile) == 0x4D42) { // BMP signature
    (void)read32(bmpFile); // Read & ignore Filesize
    (void)read32(bmpFile); // Read & ignore Creator Bytes
    bmpImageoffset = read32(bmpFile); // Start of image data
    (void)read32(bmpFile); // Read & ignore DIB Header Size
    bmpWidth  = read32(bmpFile);
    bmpHeight = read32(bmpFile);
    if(read16(bmpFile) == 1) { // # planes -- must be '1'
      bmpDepth = read16(bmpFile); // bits per pixel
      if((bmpDepth == 24) && (read32(bmpFile) == 0)) { // 0 = uncompressed
        goodBmp = true; // Supported BMP format -- proceed!
        // BMP rows are padded (if needed) to 4-byte boundary
        rowSize = (bmpWidth * 3 + 3) & ~3;
        if(bmpHeight < 0) {
          bmpHeight = -bmpHeight;
          flip      = false;
        }
        // Crop area to be loaded
        w = bmpWidth;
        h = bmpHeight;
        if((x+w-1) >= display.width())  w = display.width()  - x;
        if((y+h-1) >= display.height()) h = display.height() - y;
        // For each scanline...
        for (row=0; row<h; row++) { 
          ////display.goTo(x, y+row);
          // Seek to start of scan line.  It might seem labor-
          // intensive to be doing this on every line, but this
          // method covers a lot of gritty details like cropping
          // and scanline padding.  Also, the seek only takes
          // place if the file position actually needs to change
          // (avoids a lot of cluster math in SD library).
          if(flip) // Bitmap is stored bottom-to-top order (normal BMP)
            pos = bmpImageoffset + (bmpHeight - 1 - row) * rowSize;
          else     // Bitmap is stored top-to-bottom
            pos = bmpImageoffset + row * rowSize;
          if(bmpFile.position() != pos) { // Need seek?
            bmpFile.seek(pos);
            buffidx = sizeof(sdbuffer); // Force buffer reload
          }
          // optimize by setting pins now
          for (col=0; col<w; col++) { // For each pixel...
            // Time to read more pixel data?
            if (buffidx >= sizeof(sdbuffer)) { // Indeed
              bmpFile.read(sdbuffer, sizeof(sdbuffer));
              buffidx = 0; // Set index to beginning
            }
            // Convert pixel from BMP to display format, push to display
            b = sdbuffer[buffidx++];
            g = sdbuffer[buffidx++];
            r = sdbuffer[buffidx++];
            display.drawPixel(x+col, y+row, display.Color565(r,g,b));
            ////display.pushColor(display.Color565(r,g,b));
          } // end pixel
        } // end scanline
      } // end goodBmp
    } // end # planes
  } // end BMP signature
  bmpFile.close();
  ////if(!goodBmp) Serial.println("BMP format not recognized.");
}

// These read 16- and 32-bit types from the SD card file.
// BMP data is stored little-endian, Arduino is little-endian too.
// May need to reverse subscript order if porting elsewhere.
uint16_t read16(File f) {
  uint16_t result;
  ((uint8_t *)&result)[0] = f.read(); // LSB
  ((uint8_t *)&result)[1] = f.read(); // MSB
  return result;
}
uint32_t read32(File f) {
  uint32_t result;
  ((uint8_t *)&result)[0] = f.read(); // LSB
  ((uint8_t *)&result)[1] = f.read();
  ((uint8_t *)&result)[2] = f.read();
  ((uint8_t *)&result)[3] = f.read(); // MSB
  return result;
}
//-----Bitmap end

void testlines(uint16_t color) {
  display.clearScreen();
  for (int16_t x=0; x < 96-1; x+=6) {
    display.drawLine(0, 0, x, 64-1, color);
  }
  for (int16_t y=0; y < 64-1; y+=6) {
    display.drawLine(0, 0, 96-1, y, color);
  }
  display.clearScreen();
  for (int16_t x=0; x < 96-1; x+=6) {
    display.drawLine(96-1, 0, x, 64-1, color);
  }
  for (int16_t y=0; y < 64-1; y+=6) {
    display.drawLine(96-1, 0, 0, y, color);
  }

  display.clearScreen();
  for (int16_t x=0; x < 96-1; x+=6) {
    display.drawLine(0, 64-1, x, 0, color);
  }
  for (int16_t y=0; y < 64-1; y+=6) {
    display.drawLine(0, 64-1, 96-1, y, color);
  }
  display.clearScreen();
  for (int16_t x=0; x < 96-1; x+=6) {
    display.drawLine(96-1, 64-1, x, 0, color);
  }
  for (int16_t y=0; y < 64-1; y+=6) {
    display.drawLine(96-1, 64-1, 0, y, color);
  }
  delay(500);
}


void testdrawtext(char *text, uint16_t color) {
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(0,0);

  for (uint8_t i=0; i < 168; i++) {
    if (i == '\n') continue;
    display.write(i);
    if ((i > 0) && (i % 21 == 0))
      display.println();
  }    
}

void testfastlines(uint16_t color1, uint16_t color2) {
  display.clearScreen();
  for (int16_t y=0; y < 64-1; y+=5) {
    display.drawFastHLine(0, y, 96-1, color1);
  }
  for (int16_t x=0; x < 96-1; x+=5) {
    display.drawFastVLine(x, 0, 64-1, color2);
  }
}

void testdrawrects(uint16_t color) {
  display.clearScreen();
  for (int16_t x=0; x < 64-1; x+=6) {
    display.drawRect((96-1)/2 -x/2, (64-1)/2 -x/2 , x, x, color);
  }
}

void testfillrects(uint16_t color1, uint16_t color2) {
  display.clearScreen();
  for (int16_t x=64-1; x > 6; x-=6) {
    display.fillRect((96-1)/2 -x/2, (64-1)/2 -x/2 , x, x, color1);
    display.drawRect((96-1)/2 -x/2, (64-1)/2 -x/2 , x, x, color2);
  }
}

void testfillcircles(uint8_t radius, uint16_t color) {
  for (uint8_t x=radius; x < 96-1; x+=radius*2) {
    for (uint8_t y=radius; y < 64-1; y+=radius*2) {
      display.fillCircle(x, y, radius, color);
    }
  }  
}

void testdrawcircles(uint8_t radius, uint16_t color) {
  for (int16_t x=0; x < 96-1+radius; x+=radius*2) {
    for (int16_t y=0; y < 64-1+radius; y+=radius*2) {
      display.drawCircle(x, y, radius, color);
    }
  }  
}

void testtriangles() {
  display.clearScreen();
  int color = 0xF800;
  int t;
  int w = 96/2;
  int x = 64;
  int y = 0;
  int z = 96;
  for(t = 0 ; t <= 15; t+=1) {
    display.drawTriangle(w, y, y, x, z, x, color);
    x-=4;
    y+=4;
    z-=4;
    color+=100;
  }
}

void testroundrects() {
  display.clearScreen();
  int color = 100;
  int i;
  int t;
  for(t = 0 ; t <= 4; t+=1) {
    int x = 0;
    int y = 0;
    int w = 96;
    int h = 64;
    for(i = 0 ; i <= 24; i+=1) {
      display.drawRoundRect(x, y, w, h, 5, color);
      x+=2;
      y+=3;
      w-=4;
      h-=6;
      color+=1100;
    }
    color+=100;
  }
}

void tftPrintTest() {
  display.clearScreen();
  display.setCursor(0, 5);
  display.setTextColor(RED);  
  display.setTextSize(1);
  display.println("Hello World!");
  display.setTextColor(YELLOW, GREEN);
  display.setTextSize(2);
  display.print("Hello Wo");
  display.setTextColor(BLUE);
  display.setTextSize(3);
  display.print(12.57);
  delay(2000);
  display.setCursor(0, 5);
  display.clearScreen();
  display.setTextColor(WHITE);
  display.setTextSize(0);
  display.println("Hello World!");
  display.setTextSize(1);
  display.setTextColor(GREEN);
  display.print(p, 5);
  display.println(" Want pi?");
  display.print(8675309, HEX); // print 8,675,309 out in HEX!
  display.print(" Print HEX");
  display.setTextColor(WHITE);
  display.println("Sketch has been");
  display.println("running for: ");
  display.setTextColor(MAGENTA);
  display.print(millis() / 1000);
  display.setTextColor(WHITE);
  display.print(" seconds.");
}


/**************************************************************************/
/*! 
 @brief  Renders a simple test pattern on the LCD
 */
/**************************************************************************/
void lcdTestPattern(void)
{
  uint32_t i,j;
  display.goTo(0, 0);

  for(i=0;i<64;i++)
  {
    for(j=0;j<96;j++)
    {
      if(i>55){
        display.writeData(WHITE>>8);
        display.writeData(WHITE);
      }
      else if(i>47){
        display.writeData(BLUE>>8);
        display.writeData(BLUE);
      }
      else if(i>39){
        display.writeData(GREEN>>8);
        display.writeData(GREEN);
      }
      else if(i>31){
        display.writeData(CYAN>>8);
        display.writeData(CYAN);
      }
      else if(i>23){
        display.writeData(RED>>8);
        display.writeData(RED);
      }
      else if(i>15){
        display.writeData(MAGENTA>>8);
        display.writeData(MAGENTA);
      }
      else if(i>7){
        display.writeData(YELLOW>>8);
        display.writeData(YELLOW);
      }
      else {
        display.writeData(BLACK>>8);
        display.writeData(BLACK);
      }
    }
  }
}


void randomRect(bool fill){
  display.clearScreen();
  uint8_t k,c;
  for (k = 0; k < 16; k++) {
    for (c = 0; c < 32; c++) {
      uint8_t cx, cy, x, y, w, h;
      //  center
      cx = random(0,96);//cx = rand() % 96;
      cy = random(0,64);//cy = rand() % 64;
      //  size
      w = random(0,30 + 6);//w = rand() % 30 + 6;
      h = random(0,20 + 4);//h = rand() % 20 + 4;
      //  upper-left
      x = cx - w / 2;
      y = cy - h / 2;
      if (x < 0) x = 0;
      if (y < 0) y = 0;
      //  adjust size
      if (x + w > 96) w = 96 - x;
      if (y + h > 64) h = 64 - y;
      if (fill){
        display.fillRect(x, y, w, h,random(0x0010,0xFFFF));
      } 
      else {
        display.drawRect(x, y, w, h,random(0x0010,0xFFFF));
      }

    }
    display.clearScreen();
  }
}

void randomCircles(bool fill){
  display.clearScreen();
  uint8_t k,c;
  for (k = 0; k < 64; k++) {
    for (c = 0; c < 32; c++) {
      //  coordinates
      uint8_t x = random(0,90 + 3), y = random(0,60 + 2), r = random(0,20 + 1);
      if (x - r <  0) r = x;
      if (x + r > 95) r = 95 - x;
      if (y - r <  0) r = y;
      if (y + r > 63) r = 63 - y;
      if (fill){
        display.fillCircle(x, y, r,random(0x0010,0xFFFF));
      } 
      else {
        display.drawCircle(x, y, r,random(0x0010,0xFFFF));
      }
    }
    display.clearScreen();
  }
}


void randomLines(){
  display.clearScreen();
  uint8_t k,c;
  for (k = 0; k < 64; k++) {
    for (c = 0; c < 32; c++) {
      uint8_t x1 = random(0,96), y1 = random(0,64), x2 = random(0,96), y2 = random(0,64);
      display.drawLine(x1, y1, x2, y2,random(0x0010,0xFFFF));
    }
    display.clearScreen();
  }
}


void randomPoints(){
  display.clearScreen();
  int k,c;
  for (k = 0; k < 128; k++) {
    for (c = 0; c < 1000; c++) {
      uint8_t x = random(0,96), y = random(0,64);
      display.drawPixel(x, y,random(0x0010,0xFFFF));
    }
    display.clearScreen();
  }
}
